/*
        FX.C by Ryan M. Geiss
	------------------------------------
	
	Allows rotation, vortices, anything!
	There is a slight fade effect at the end of the pixel calculation.  It is
		extremely gradual.  You can pop a manual decrement in if you like.
	If you want to get the original trail paths for the chasers for the solar
		flare (for a demo), use the old, commented-out chaser movement patterns.	

	v2.20: replaced the huge array with two far arrays -> 25% speed boost (->enlarged viewport)


	1. major hurdle: store word as (word%256) then (word/256)!
*/




#include "gvid32.h"
#include "stdio.h"
#include "conio.h"
#include "math.h"
#include "time.h"

#define TIME_SPEED 0.05
float time_seed = 0;


char as[2][2][2][2];




//unsigned char far *VS1 = NULL;
//unsigned char far *VS2 = NULL;
unsigned char far *DATA_1 = NULL;  // each is a 57288 byte chunk
unsigned char far *DATA_2 = NULL;  //   -holds data for a 308x31 screen chunk; each
unsigned char far *DATA_3 = NULL;  //    pixel has 6 bytes of info saved for it:
unsigned char far *DATA_4 = NULL;  //    d1,d2,d3,d4, and the offset to look at.
unsigned char far *DATA_5 = NULL;
unsigned char far *DATA_6 = NULL;
unsigned char far *DATA_X  = NULL;  // just used for pointing; no allocation.
unsigned int  far *DATA_XX = NULL;  // just used for pointing; no allocation.


void Solid_Line(float frame, unsigned char far *VS2);
void Two_Chasers(float frame, unsigned char far *VS2);
void PalGen();
void PalGen2();
void MadPalGen();

void VS_Ascii_Paste(unsigned char *buf);


void main(int num_args, char *argv[])
{
        as[0][0][0][0] = ' ';
        as[0][0][0][1] = '.';
        as[0][0][1][0] = ',';
        as[0][0][1][1] = '_';
        as[0][1][0][0] = '\'';
        as[0][1][0][1] = ']';
        as[0][1][1][0] = '/';
        as[0][1][1][1] = 'J';
        as[1][0][0][0] = '`';
        as[1][0][0][1] = '\\';
        as[1][0][1][0] = '[';
        as[1][0][1][1] = 'L';
        as[1][1][0][0] = '~';
        as[1][1][0][1] = '7';
        as[1][1][1][0] = 'P';
        as[1][1][1][1] = 'O';

	int effect_1=1, effect_2=-1, sun_effect=-1;
	unsigned int a, b, addr, z1, z2, mode;
	long k, k1, k2, intframe=0;
	float newx, newy, newx2, newy2, floatframe=0;
	float scale1, scale2, turn1, turn2, x_trans=0, y_trans=0;
	unsigned char quitnow=0;
	unsigned char p1, p2, p3;

	int x, y, solar_max, initial_sun = 0;
	float center_dwindle;
	unsigned int fx, z, A_offset, A_number, R_offset, D_offset;

	srand(time(NULL));

	printf("\nAllocating 471k of memory from your first meg...\n");
	VS1     = new far unsigned char[64000]; if (VS1 == 0)	{ printf("Not enough conventional memory!\n"); exit(5); }
	VS2     = new far unsigned char[64000]; if (VS2 == 0)	{ printf("Not enough conventional memory!\n"); exit(5); }
	DATA_1   = new far unsigned char[57288]; if (DATA_1 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	DATA_2   = new far unsigned char[57288]; if (DATA_2 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	DATA_3   = new far unsigned char[57288]; if (DATA_3 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	DATA_4   = new far unsigned char[57288]; if (DATA_4 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	DATA_5   = new far unsigned char[57288]; if (DATA_5 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	DATA_6   = new far unsigned char[57288]; if (DATA_6 == 0) { printf("Not enough conventional memory!\n"); exit(5); }
	printf("Memory hogged.  Doing Precalx... Brace yourself...\n");

	Buffer_Clear(VS1);
	Buffer_Clear(VS2);


	mode = 1 + rand() % 6;

	if (num_args>=2)
	{
		if (argv[1][0] == '1') mode=1;
		else if (argv[1][0] == '2') mode=2;
		else if (argv[1][0] == '3') mode=3;
		else if (argv[1][0] == '4') mode=4;
		else if (argv[1][0] == '5') mode=5;
		else if (argv[1][0] == '6') mode=6;
		else if (argv[1][0] == '9') mode=9;
	}
	if (num_args == 3)
	{
		srand(time(argv[2]));
		floatframe = rand() % 1000 + (rand() % 1000)*0.001;		
	}


	if (mode==1) {
		scale1 = 0.98;    turn1 = 0.01;  
		scale2 = 0.98;    turn2 = 0.01;	  
		solar_max = 1100;
		center_dwindle = 1.00;
		initial_sun = 1;
	} else if (mode==2) {
		scale1 = 0.98;  	turn1	 = 0.02;	
		scale2 = 0.98;  	turn2	 = 0.03;	
		solar_max = 1100;
		sun_effect = 1;
		center_dwindle = 1.00;
		initial_sun = 1;
	} else if (mode==3) {
		scale1 = 0.9 ;  	turn1	 =  0.05;
		scale2 = 0.9 ;  	turn2	 =  0.05;	
		solar_max = 400;
		sun_effect = 1;
		center_dwindle = 0.99;
	} else if (mode==4) {
		scale1 = 0.9 ;  	turn1	 =  0.02;
		scale2 = 0.9 ;  	turn2	 =  0.02;	
		solar_max = 400;
		center_dwindle = 0.99;
	} else if (mode==5) {
		//scales will be handled by the map generator - change w/dist from center
		turn1 = 0.02;
		turn2 = 0.02;
		solar_max = 400;
		sun_effect = 1;
		center_dwindle = 0.985;
	} else if (mode==6) {
		//scales will be handled by the map generator - change w/dist from center
		turn1 = 0.02;
		turn2 = 0.02;
		solar_max = 400;
		sun_effect = 1;
		center_dwindle = 0.985;
	} else if (mode==9) {
		//scales will be handled by the map generator - change w/dist from center
		turn1 = 0.02;
		turn2 = 0.02;
		solar_max = 400;
		sun_effect = 1;
		center_dwindle = 0.985;
	}


	//scale1 = 1.00010 ; 	turn1	 =  0.0001;
	//scale2 = 1.00010 ; 	turn2	 =  0.0001;	

	if (mode==9)
	{
		srand(time(NULL));
		p1 = rand() % 10;
		p2 = rand() % 10;
		p3 = rand() % 4;
	}

	k = 0;
	for (y = 7; y<=192; y++)
		for (x = 6; x<=313; x++)
		{ 

			//k									// this is the k'th pixel processed; SKIPS BLANK PIXELS, LIKE THE ARRAYS
			R_offset = 64000;					// dest. read pixel offset: 0..63999, 64000 for null
			A_offset = (k%9548)*6;			// for the array:           0...9547*6
			A_number = k/9548;				// which of the 6 arrays we're on (0..5)

			newx2 = x - 159;
			newy2 = y - 99;


			//---------------------------------------------------------------------------------------------------
			if (mode==5)
			{
				scale1 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.008;
				scale2 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.008;
			}

			if (mode==6)
			{
				scale1 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0028;
				scale2 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0028;
			}

			if (mode==9)
			{
				if (p3==0)
				{
					scale1 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0018*cos(newx2*0.04 + p1);
					scale2 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0018*sin(newy2*0.04 + p2);
				}
				else if (p3==1)
				{
					scale1 = 0.95;
					scale2 = 0.95;
					turn1 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0018*cos(newx2*0.04 + p1);
					turn2 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0018*sin(newy2*0.04 + p2);
				}
				else if (p3==2)
				{
					scale1 = 0.97;
					scale2 = 0.97;
					turn1 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.003*cos(newx2*0.03 + p1);
					turn2 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.003*sin(newy2*0.03 + p2);
				}
				else if (p3==3)
				{
					scale1 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0005*cos(newx2*0.04 + p2);
					scale2 = 0.9 - sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0005*sin(newy2*0.04 + p1);
					turn1 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0005*cos(newx2*0.03 + p1);
					turn2 = -sqrt(newx2*newx2 + newy2*newy2*1.2)*0.0005*sin(newy2*0.03 + p2);
				}
			}
			//---------------------------------------------------------------------------------------------------

			if (     (x%2==1) == (y%2)     )
			{
			   newx = newx2*cos(turn1)  - newy2*sin(turn1) ;    //Z rotation
			   newy = newx2*sin(turn1)  + newy2*cos(turn1) ;
				newx = (newx)*scale1 + 159 + x_trans;
				newy = (newy)*scale1 +  99 + y_trans;
			}
			else
			{
			   newx = newx2*cos(turn2) - newy2*sin(turn2) ;    //Z rotation
			   newy = newx2*sin(turn2) + newy2*cos(turn2) ;
				newx = (newx)*scale2 + 159 + x_trans;
				newy = (newy)*scale2 +  99 + y_trans;
			}

			//COOL GRAINY TEXTURE
			//newx += (rand() % 1000)*0.001 - 0.5;
			//newy += (rand() % 1000)*0.001 - 0.5;

			// DEBUG: point to exact same pixel.
			//newx = newx2 + 159;
			//newy = newy2 + 99;

			if (((newx < 6) || (newx > 313)) || ((newy < 7) || (newy > 192)))
			{
				a = 320;
				b = 200;
				R_offset = 500;
			}
			else
			{
				a = (unsigned int)newx;
				b = (unsigned int)newy;
				R_offset = b*320 + a + 4;  // (c)rackhead patch aler(t)

				newx2 = (newx - a);
				newy2 = (newy - b);
			}



			//printf("(%d,%d) to (%u,%u) \n", x, y, a, b);

			//printf("offset %u:   ", k2);

			if (A_number == 0) {
				DATA_1[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_1[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_1[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_1[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_1[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_1[A_offset + 5] = (unsigned char)(R_offset/256);
			} else if (A_number == 1) {
				DATA_2[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_2[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_2[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_2[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_2[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_2[A_offset + 5] = (unsigned char)(R_offset/256);
			} else if (A_number == 2) {
				DATA_3[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_3[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_3[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_3[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_3[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_3[A_offset + 5] = (unsigned char)(R_offset/256);
			} else if (A_number == 3) {
				DATA_4[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_4[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_4[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_4[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_4[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_4[A_offset + 5] = (unsigned char)(R_offset/256);
			} else if (A_number == 4) {
				DATA_5[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_5[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_5[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_5[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_5[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_5[A_offset + 5] = (unsigned char)(R_offset/256);
			} else {
				DATA_6[A_offset + 0] = (unsigned char)((1-newx2)*(1-newy2)*255);  // stores (0-255) TOPLEFT's weight
				DATA_6[A_offset + 1] = (unsigned char)((  newx2)*(1-newy2)*255);  // stores (0-255) TOPRIGHT's weight
				DATA_6[A_offset + 2] = (unsigned char)((1-newx2)*(  newy2)*255);  // stores (0-255) BTMLEFT's weight
				DATA_6[A_offset + 3] = (unsigned char)((  newx2)*(  newy2)*255);  // stores (0-255) BTMRIGHT's weight
				DATA_6[A_offset + 4] = (unsigned char)(R_offset%256);
				DATA_6[A_offset + 5] = (unsigned char)(R_offset/256);
			}			
																					 // ...all 4 would add to 256.
  	
			// sun
			if (initial_sun)
			{
				newx = sqrt((newx-160)*(newx-160) + (newy-100)*(newy-100)*1.2);
				if (newx<65) VS1[y*320+x] = 195-newx*3;
				        else VS1[y*320+x] = 0;
				if ((mode==4) || (mode==3)) VS1[y*320+x] *= 0.6;
			}
  			//VS1[y*320+x] = rand() % 64;

			//if (DATA_X==DATA_3)
			//printf("sum=%u, offsetptr=%u\n", DATA_3[A_offset]+DATA_3[A_offset+1]+DATA_3[A_offset+2]+DATA_3[A_offset+3], ( DATA_3[A_offset+4] + DATA_3[A_offset+5]*256) );
			//putpixel(a, b, R_offset);

			k++;           // for array access
		}


	//for (z=0; z<9548; z++) printf("%3u %3u %3u %3u %3u %3u\n", DATA_2[z*6], DATA_2[z*6+1], DATA_2[z*6+2], DATA_2[z*6+3], DATA_2[z*6+4], DATA_2[z*6+5] );

	set13();
	//setfunky(0);
	PalGen();




	while (!quitnow)
	{
		intframe++;
      time_seed += TIME_SPEED;

		for (A_number=0; A_number<=5; A_number++)
		{

			if      (A_number == 0) DATA_X = DATA_1;
			else if (A_number == 1) DATA_X = DATA_2;
			else if (A_number == 2) DATA_X = DATA_3;
			else if (A_number == 3) DATA_X = DATA_4;
			else if (A_number == 4) DATA_X = DATA_5;
			else   					   DATA_X = DATA_6;

			z = 0;

			//for (y = 7; y<192; y++)
			for (y = 7+A_number*31; y <  7+(A_number+1)*31; y++)
			//for (x = 6; x<=313; x++)
			{

				D_offset = y*320 + 6;		// pt. on screen to write result to.

				// loop from D_offset+6 to D_offset+313, inclusive:

			   asm 
			   {

					//mov   dx, 6

						mov   ax, word ptr z
						lgs	si, dword ptr DGROUP:_DATA_X
						add   si, ax

						mov   ax, word ptr D_offset
						add   ax, 4
						push  bp
					   lfs 	bp, VS2
						mov   bp, ax

					   les 	di, VS1


						mov   ax, 313-6+1
	
						@PixelLoop:
	
								ror   eax,16

									mov	bx,word ptr gs:[si+2]		// now CL/CH/BL/BH have the 4 f_ byte values
									mov   ax,word ptr gs:[si+4]		// now AX stores the read offset
									mov	cx,word ptr gs:[si+0]		// D_offset stores the write offset
									mov   di, ax
					
							      mov       al, ES:[di]                             // moves [ds:si] to al (1 byte) & inc. si
							      inc       di
									mul       cl
									mov       dx, ax
				
							      mov       al, ES:[di]                             // moves [ds:si] to al (1 byte) & inc. si
									add       di, 319
									mul       ch
							      add       dx, ax
				
							      mov       al, ES:[di]                             // moves [ds:si] to al (1 byte) & inc. si
							      inc       di
									mul       bl
							      add       dx, ax
				
							      mov       al, ES:[di]                             // moves [ds:si] to al (1 byte) & inc. si
									mul       bh
									add       dx, ax
				
									 // now DH stores the averaged color value.

								ror   eax,16

			 					mov	FS:[bp], dh			// plot it
								inc   bp						// move along the screen
								add 	si, 6					// move along DATA_X

								dec   ax
								jnz   @PixelLoop

						pop bp
			   }

					
				
				//R_offset = ((unsigned char)DATA_X[z+5]);
				//R_offset *= 256;
				//R_offset += ((unsigned char)DATA_X[z+4]);
				//printf("%u\n", abs(D_offset-R_offset));
				//printf("%u vs %u\n", D_offset, R_offset);
			   
				//if (fx>0) fx--;
				//VS2[D_offset] = fx;// + rand() % 5;//VS1[R_offset];//1[ DATA_X[z+4]+DATA_X[z+5]*256 ]; //fx;

				z+=6*(313-6+1);

			}
		}



      wait_refresh();
      Buffer_Paste(VS2);
      wait_refresh();


		//------EFFECTS----------------------------------------------------------------------------------------------------
		if (effect_1==1) Two_Chasers(floatframe, VS2);
		if (effect_2==1) Solid_Line(floatframe, VS2);
		
		if (sun_effect==1)
		{
			
			for (k=solar_max; k>0; k--)
			{
				y = rand() % (192-7+1) + 7;
				x = rand() % (313-6+1) + 7;
	
				newy = y;
				newx = x;
	
				newx = sqrt((newx-160)*(newx-160) + (newy-100)*(newy-100)*1.2);
				if (newx<65) z = 195-newx*3;
				        else z = 0;
				//if (mode==3) z = 0;
				//if (mode==4) z *= 0.6;
				if (VS2[y*320+x] < z) VS2[y*320+x] = z;
			}

		}

		if (VS2[159 + 99*320] > 1) VS2[159 + 99*320] *= center_dwindle;
		if (VS2[158 + 99*320] > 1) VS2[158 + 99*320] *= center_dwindle;
		if (VS2[160 + 99*320] > 1) VS2[160 + 99*320] *= center_dwindle;
		if (VS2[159 +100*320] > 1) VS2[159 +100*320] *= center_dwindle;
		if (VS2[159 + 98*320] > 1) VS2[159 + 98*320] *= center_dwindle;


		//----------------------------------------------------------------------------------------------------------




		//Buffer_Swap(VS1, VS2);
		tempptr = VS1;
		VS1 = VS2;
		VS2 = tempptr;

		if (kbhit())
		{
			fx = getch();

			if (fx==27) quitnow=1;
			if (fx=='l') put_TGA_to_buffer("razma.tga", VS1);
			if (fx=='r') for (y = 7; y<=192; y++) for (x = 6; x<=313; x++) VS1[y*320+x] = rand() % 64;
			if (fx=='1') effect_1 *= -1;
			if (fx=='2') effect_2 *= -1;
			if (fx=='s') sun_effect *= -1;
			if (fx=='p') PalGen();
			if (fx=='P') PalGen2();
			if (fx=='c') MadPalGen();

		}

		floatframe += 1.6;
		//putpixel(rand() % 320, rand() % 200, rand() % 64);

	}		

	settext();

	delete VS1;
	delete VS2;
	delete DATA_1;
	delete DATA_2;
	delete DATA_3;
	delete DATA_4;
	delete DATA_5;
	delete DATA_6;

	printf("\nFX v2.30 - a subpixel blur engine written by Ryan Geiss in C++/asm, 2/98\n");
	printf("Fully optimized for Intel Pentium.\n\n");
        printf("Add a number 1-6 as a command-line parameter to specify which of the\n");
        printf("six modes to use; otherwise one is selected randomly.  Add a second\n");
	printf("parameter for a random seed.  Hotkeys are:\n\n");
	printf("   1: toggle chaser_1 on/off\n");
	printf("   2: toggle chaser_2 on/off\n");
	printf("   s: toggle solar particles on/off\n");
	printf("   p: change palette (1 of 4 duotones)\n");
	printf("   P: change palette (1 of 4 semi-chaotic duotones)\n");
	printf("   c: crazy palette (random)\n");
	printf("\n");
	printf("mode:   %u\n", mode);
	printf("fps:    %7.5f\n\n", intframe / (float)(clock()/CLOCKS_PER_SEC));

}




void Two_Chasers(float frame, unsigned char far *VS2)
{
		unsigned int k, a, b;

		for (k=0; k<20; k++)
		{
			frame = frame + 0.08;
			//a = 159 + (54*cos(frame*0.11+10) +  45*cos(frame*0.13+20));  // DO NOT
			//b =  99 + (34*cos(frame*0.12+40) +  35*cos(frame*0.17+30));  // ERASE!
			a = 159 + (54*cos(frame*0.1102+10) +  45*cos(frame*0.1312+20));  
			b =  99 + (34*cos(frame*0.1204+40) +  35*cos(frame*0.1715+30));  
			VS2[b*320+a] = 255;

			//a = 159 + (44*cos(frame*0.12+33) +  35*cos(frame*0.14+15));  // DO NOT
			//b =  99 + (32*cos(frame*0.13+12) +  31*cos(frame*0.11+21));  // ERASE!
			a = 159 + (44*cos(frame*0.1213+33) +  35*cos(frame*0.1408+15));  
			b =  99 + (32*cos(frame*0.1304+12) +  31*cos(frame*0.1103+21));  
			VS2[b*320+a] = 255;

		}
}


void Solid_Line(float frame, unsigned char far *VS2)
{
		unsigned int k, a, b, k2;
		float newx, newy, newx2, newy2;

		frame = frame*0.55/(0.08*20);
		newx = 159 + (16*cos(frame*0.1102+10) +  15*cos(frame*0.1312+20));  // DO NOT
		newy =  99 + (15*cos(frame*0.1204+40) +  10*cos(frame*0.1715+30));  // ERASE!
		newx2 = 159 + (14*cos(frame*0.1213+33) +  13*cos(frame*0.1408+15));  // DO NOT
		newy2 =  99 + (13*cos(frame*0.1304+12) +  11*cos(frame*0.1103+21));  // ERASE!

		for (k=0; k<50; k++)
		{
			a = newx*(k/50.0) + newx2*(1-k/50.0);
			b = newy*(k/50.0) + newy2*(1-k/50.0);
			k2 = b*320+a;
			if (VS2[k2] < 230) VS2[k2] += 20;
		}

}


void PalGen()
{
	int a, k = rand() % 4;

	if (k==0) {
		for (a=0; a<64; a++) setRGB(a, a, a*a/64.0, sqrt(a)*8);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "purple majik"
	} else if (k==1) {
		for (a=0; a<64; a++) setRGB(a, a*a/64.0, sqrt(a)*8, a);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "green lantern II"
	} else if (k==2) {
		for (a=0; a<64; a++) setRGB(a, sqrt(a)*8, a, a*a/64.0);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "amber sun"
	} else if (k==3) {
		for (a=0; a<64; a++) setRGB(a, a*a/64.0, a, sqrt(a)*8);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"
	}

}

void MadPalGen()
{
	int j1, j2, j3, a;

	j1 = rand() % 5 + 2;
	j2 = rand() % 5 + 2;
	j3 = rand() % 5 + 2;
	for (a=0; a<64; a++) setRGB(a, a*j1, a*j2, a*j3);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "purple majik"
}

void PalGen2()
{
	int a, k = rand() % 5;

	if (k==0) {
		for (a=0; a<64; a++) setRGB(a, a, sqrt(a)*8, sin(a/63.0*6.2 - 1.6)*31+32);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"		
	} else if (k==1) {
		for (a=0; a<64; a++) setRGB(a, sin(a/63.0*6.2 - 1.6)*31+32, a, sqrt(a)*8);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"
	} else if (k==2) {
		for (a=0; a<64; a++) setRGB(a, a, sin(a/63.0*6.2 - 1.6)*31+32, a*a/64);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"		
	} else if (k==3) {
		for (a=0; a<64; a++) setRGB(a, sqrt(a)*8, a*a/64, sin(a/63.0*6.2 - 1.6)*31+32);	for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"		
	} else if (k==4) {
		for (a=0; a<32; a++) setRGB(a, 0, 0, 0);
		for (a=0; a<32; a++) setRGB(a+32, sqrt(a)*10, a*2, a*2 );	
		for (a=64; a<256; a++) setRGB(a, 63, 63, 63);  // "frosty"		
	}

}




void VS_Ascii_Paste(unsigned char *buf)
{
   printf("\n");

   int a, b, w, x, y, z;

   for (a=0; a<25; a++)
     for (b=0; b<80; b++)
     {
         w = buf[   b*2 + a*2     ] > 50;
         x = buf[   b*2 + a*2 +1  ] > 50;
         y = buf[   b*2 + a*2 +160] > 50;
         z = buf[   b*2 + a*2 +161] > 50;
         printf("%c", as[w][x][y][z]);
     }


}


